#include <avr/io.h>
#include <avr/interrupt.h>

/*sonar*/
int arraysize = 9;
int go = 0;
int gopro=0;
int sensVal[] = {0,0};
int sensMax = 56;
int sensMin = 24;
const int pwPin = 11;
const int motor = 3;

int values[8] = {0, 0, 0, 0, 0, 0, 0, 0};
int pulse;
int median;
/*sonar end*/
int timer;
unsigned int motorTimer;
unsigned long LCDtimer;
unsigned int LCDdispStuff;
String announce[]={"1.INSERT YOUR FINGER","","2.SENSE THE DISTANCE", "to THE PLANE","IrukaTact",""};
int announce_startPos[]={2,3,34};
const int LCDclearTime=200;
boolean isHand,isSleep;
 
#include "ST7565.h"

int ledPin =  13;    // LED connected to digital pin 13

// the LCD backlight is connected up to a pin so you can turn it on & off
#define BACKLIGHT_LED 10

// pin 9 - Serial data out (SID)
// pin 8 - Serial clock out (SCLK)
// pin 7 - Data/Command select (RS or A0)
// pin 6 - LCD reset (RST)
// pin 5 - LCD chip select (CS)
ST7565 glcd(9, 8, 7, 6, 5);

#define LOGO16_GLCD_HEIGHT 16 
#define LOGO16_GLCD_WIDTH  16 

// a bitmap of a 16x16 fruit icon
const static unsigned char __attribute__ ((progmem)) logo16_glcd_bmp[]={
0x30, 0xf0, 0xf0, 0xf0, 0xf0, 0x30, 0xf8, 0xbe, 0x9f, 0xff, 0xf8, 0xc0, 0xc0, 0xc0, 0x80, 0x00, 
0x20, 0x3c, 0x3f, 0x3f, 0x1f, 0x19, 0x1f, 0x7b, 0xfb, 0xfe, 0xfe, 0x07, 0x07, 0x07, 0x03, 0x00, };

// The setup() method runs once, when the sketch starts
void setup()   {                
  //Serial.begin(9600);
  Serial.begin(115200);
  Serial.print(freeRam());
  
  // turn on backlight
  pinMode(BACKLIGHT_LED, OUTPUT);
//  digitalWrite(BACKLIGHT_LED, HIGH);
  pinMode(pwPin, INPUT); //setup pwPin to measure pulse width
  pinMode(motor, OUTPUT); //setup pwPin to measure pulse width 
  // initialize and set the contrast to 0x18
  glcd.begin(0x18);
  delay(1000);
  glcd.clear();
}


void loop(){//sonar part
  //takes 9 samples
 
  for (int i = 0;i<arraysize; i++)
  {
    pulse = pulseIn(pwPin, HIGH);
  
    values[i] = pulse / 58; //specified uS/cm for sonar in air
    //values[i] = values[i]*4; //to account for 4x speed in water
    delay(10);
  }


  //bubble sort to find median
  bubbleSort(values, arraysize);
  int median = values[4]; //use 4th value of array as median
  Serial.print("Median(cm): ");
  Serial.println(median);
  sensVal[1]=sensVal[0];
  sensVal[0] = constrain(median, sensMin, sensMax);

  gopro= map(sensVal[0], sensMin, sensMax, 100, 255);
   if (median >= sensMax||median <= sensMin){
     gopro= 0;
     timer++;
     if(timer>5)isHand=false;
   }else if(!isHand){
     isHand=true;
     timer=0;
   }
     
   //delay:50~150
   int delayyyy=50;
   for(int i=0;i<18;i++){
    if(i%2!=0){
     go= gopro;  
    }else{
     go=0;
      delayyyy=map(sensVal[0]*sensVal[0], sensMin*sensMin, sensMax*sensMax, 150, 50);
      delay(delayyyy);
      
    }  
    analogWrite(motor, go);
    delay(10);
  }

 
     LCDdisp();
   
   Serial.print("sensval: ");
  Serial.println(sensVal[0]);
   Serial.print("go");
  Serial.println(gopro);
  
  
  
}
//sorts data using the "bubble sort" method
void bubbleSort(int *a, int n) {
  for (int i = 1; i < n; i++)
  {
    int j = a[i];
    int k;
    for (k = i - 1; (k >= 0) && (j < a[k]); k--)
    {
      a[k + 1] = a[k];
    }
    a[k + 1] = j;
  }
  int med = a[3];
}
void LCDdisp(){//call LCD when distance changed
   //if(sensVal[0]!=sensVal[1]||!isHand){
    if(isHand){
      int dis=sensMax-sensVal[0];
        String str=String(dis)+" cm";
        glcd.drawstring(20, 2,"MIN distance>>");
        glcd.drawstring(20, 3,"MAX jetspeed");
        glcd.drawstring(40, 4, &str[0]);
    }else{
        glcd.drawstring(announce_startPos[LCDdispStuff], 3, &announce[LCDdispStuff*2][0]);    
        glcd.drawstring(announce_startPos[LCDdispStuff], 4, &announce[LCDdispStuff*2+1][0]);
  }

   // }
    if(LCDtimer==0){
        glcd.display(); 
        LCDtimer=millis();
      }  
    else if(millis()-LCDtimer>=LCDclearTime){
      glcd.clear();
      LCDtimer=0;
      LCDdispStuff=(LCDdispStuff+1)%3;    
    }
   
}



